Description

When you click on Host#edit Submit button, a few orchestration tasks will be created. After that, the show page will call (via AJAX) a

few URLS to fetch 'overview', 'resources', 'nics', etc... to fill up the table on the left side. These are all irrelevant to tests that only

concern the form, and pose a problem.

Problem:

The server we test on is not multithreaded, these tasks will run sequentially. Therefore, the default Capybara waiting time, or

Capybara.default_max_time might not be enough to wait for all requests.

Solution:

We can stub out these calls, and wait until the #host-progress div has disappeared for POST/PATCH requests.

Related issues:

Related to Foreman - Bug #13293: Intermittent host#edit parameter integration... Resolved 01/20/2016

Associated revisions

Revision 1580adbe - 03/18/2016 10:41 AM - Daniel Lobato Garcia

Fixes #14067 - Host#edit integration tests should wait for tasks

When you click on Host#edit Submit button, a few orchestration tasks

will be created. After that, the show page will call (via AJAX) a few

URLS to fetch 'overview', 'resources', 'nics', etc... to fill up the

table on the left side. These are all irrelevant to tests that only

concern the form, and pose a problem as we don't explicitly wait for

them.

Problem:

The server we test on is not multithreaded, these tasks will run

sequentially. Therefore, the default Capybara waiting time, or

Capybara.default_max_time might not be enough to wait for all requests.

Solution:

We can wait until the #host-progress div has disappeared and wait for

the Host#show ajax calls using wait_for_ajax

History

#1 - 03/07/2016 05:18 AM - Daniel Lobato Garcia

- Related to Bug #13293: Intermittent host#edit parameter integration test failures after timeout added

#2 - 03/07/2016 05:21 AM - Daniel Lobato Garcia

To reproduce easily, use http://projects.theforeman.org/issues/13293#note-8

#3 - 03/07/2016 05:22 AM - The Foreman Bot

- Status changed from New to Ready For Testing

- Assignee set to Daniel Lobato Garcia
- Pull request https://github.com/theforeman/foreman/pull/3283 added

#4 - 03/18/2016 10:41 AM - Dominic Cleal

- Category changed from TFTP to Tests

- translation missing: en.field_release set to 136

#5 - 03/18/2016 11:02 AM - Daniel Lobato Garcia

- Status changed from Ready For Testing to Closed

- % Done changed from 0 to 100

Applied in changeset 1580adbec7995b3d27e55d4067a2d5a4fd34d291.
